#include <bits/stdc++.h>
using namespace std;
int resenje(long long int broj)
{
	long long int i;
	long long int d=0;
	
	long long int res=1;
	
	for(i=2;i<=broj;i++)
	{
		if(d==0)
		{
			if(broj%i==0)
			{
				d=i;
			}
		}
		if(d!=0)
		{
			res=(res xor d);
			d=0;
		}
	}
	return res;
}
int main()
{
	long long int n,k,i;
	cin>>n>>k;
	long long int niz[k],res[k];
	
	for(i=0;i<k;i++)
	{
		cin>>niz[i];    // u nizu su k brojeva
	}
	for(long long int j=0;j<k;j++)
	{
		res[j]=resenje(niz[j]);
	}
	for(long long int j=0;j<k;j++)
	{
		cout<<res[j]<<" ";
	}
}